VERSION 5.00
Begin VB.UserControl RAEdit 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3585
   ControlContainer=   -1  'True
   BeginProperty Font 
      Name            =   "Courier New"
      Size            =   9
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForwardFocus    =   -1  'True
   PaletteMode     =   4  'None
   ScaleHeight     =   240
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   239
   ToolboxBitmap   =   "RAEdit.ctx":0000
   Begin VB.Timer Timer1 
      Interval        =   50
      Left            =   3030
      Top             =   3060
   End
End
Attribute VB_Name = "RAEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'Message constants
Private Const REM_SETHILITEWORDS = &H400 + 1000 + 0   'wParam=0, lParam=lpRAFONT
Private Const REM_SETFONT = &H400 + 1000 + 1          'wParam=nColor, lParam=lpszWords
Private Const REM_SETCOLOR = &H400 + 1000 + 3         'wParam=0, lParam=lpRACOLOR
Private Const REM_GETCOLOR = &H400 + 1000 + 4         'wParam=0, lParam=lpRACOLOR
Private Const REM_SETBOOKMARK = &H400 + 1000 + 7      'wParam=Line, lParam=Type
Private Const REM_GETBOOKMARK = &H400 + 1000 + 8      'wParam=Line, lParam=0
Private Const REM_CLRBOOKMARKS = &H400 + 1000 + 9     'wParam=0, lParam=Type
Private Const REM_NXTBOOKMARK = &H400 + 1000 + 10     'wParam=Line, lParam=Type
Private Const REM_PRVBOOKMARK = &H400 + 1000 + 11     'wParam=Line, lParam=Type
Private Const REM_SETBLOCKS = &H400 + 1000 + 13       'wParam=[lpLINERANGE], lParam=lpRABLOCKDEF
Private Const REM_ISLINE = &H400 + 1000 + 14          'wParam=Line, lParam=lpszDef
Private Const REM_GETWORD = &H400 + 1000 + 15         'wParam=BuffSize, lParam=lpBuff
Private Const REM_COLLAPSE = &H400 + 1000 + 16        'wParam=Line, lParam=lpRABLOCKDEF
Private Const REM_COLLAPSEALL = &H400 + 1000 + 17     'wParam=0, lParam=lpRABLOCKDEF
Private Const REM_EXPAND = &H400 + 1000 + 18          'wParam=Line, lParam=0
Private Const REM_EXPANDALL = &H400 + 1000 + 19       'wParam=0, lParam=0

Private Const WM_SETTEXT = &HC
Private Const WM_CUT = &H300
Private Const WM_COPY = &H301
Private Const WM_PASTE = &H302
Private Const WM_CLEAR = &H303
Private Const WM_DESTROY = &H2
'Private Const WM_SETFOCUS = &H7

Private Const EM_STREAMIN = &H400 + 73
Private Const EM_STREAMOUT = &H400 + 74
Private Const EM_GETMODIFY = &HB8
Private Const EM_SETMODIFY = &HB9
Private Const EM_LINEINDEX = &HBB
Private Const EM_EXGETSEL = &H400 + 52
Private Const EM_EXSETSEL = &H400 + 55
Private Const EM_SCROLLCARET = &HB7
Private Const EM_CANUNDO = &HC6
Private Const EM_UNDO = &HC7
Private Const EM_CANREDO = &H400 + 85
Private Const EM_REDO = &H400 + 84
Private Const EM_CANPASTE = &H400 + 50
Private Const EM_FINDTEXTEX = &H400 + 79
Private Const EM_REPLACESEL = &HC2
Private Const EM_LINEFROMCHAR = &HC9

Private Const LOGPIXELSX = 88
Private Const LOGPIXELSY = 90
Private Const CF_TEXT = 1
Private Const FR_DOWN = 1
Private Const FR_WHOLEWORD = 2
Private Const FR_MATCHCASE = 4
Private Const GW_CHILD = 5
Private Const SEL_TEXT = 1
Private Const SEL_OBJECT = 2
Private Const GWL_STYLE = (-16)

Private raf As RAFONT
Private hfocus As Long
Private hREd As Long
Private bButtons As Boolean

Public Type NMHDR
  hwndFrom            As Long
  idFrom              As Long
  code                As Long
End Type

Public Type CHARRANGE
  cpMin               As Long
  cpMax               As Long
End Type

Public Type LINERANGE
  lnMin               As Long
  lnMax               As Long
End Type

Private Const BD_NONESTING = 1          'Set to true for non nested blocks
Private Const BD_DIVIDERLINE = 2        'Draws a divider line
Private Const BD_INCLUDELAST = 4        'lpszEnd line is also collapsed
Private Const BD_LOOKAHEAD = 8          'Look 500 lines ahead for the ending
Private Const BD_SEGMENTBLOCK = 16      'Segment block, collapse till next segmentblock

Public Type RABLOCKDEF
  lpszStart           As String         'Block start
  lpszEnd             As String         'Block end
  lpszNot1            As String         'Dont hide line containing this or set to NULL
  lpszNot2            As String         'Dont hide line containing this or set to NULL
  flag                As Long           '
End Type

Public Type RASELCHANGE
  nmhd                As NMHDR
  chrg                As CHARRANGE      'Current selection
  seltyp              As Long           'SEL_TEXT or SEL_OBJECT
  nline               As Long           'Line number
  cpLine              As Long           'Character position of first character
  lpLine              As Long           'Pointer to line
  nlines              As Long           'Total number of lines
  nhidden             As Long           'Total number of hidden lines
  fchanged            As Long           'TRUE if changed since last
  npage               As Long           'Page number
  nWordGroup          As Long           'Hilite word group
End Type

Private Type EDITSTREAM
  dwCookie            As Long
  dwError             As Long
  pfnCallback         As Long
End Type

Private Type RAFONT
  hFont               As Long   'Normal font
  hIFont              As Long   'Italics font
  hLnrFont            As Long   'Line number font
End Type

Public Type RACOLOR
  bckcol              As Long   'Back color
  txtcol              As Long   'Text color
  selbckcol           As Long   'Sel back color
  seltxtcol           As Long   'Sel text color
  cmntcol             As Long   'Comment color
  strcol              As Long   'String color
  oprcol              As Long   'Operator color
  hicol1              As Long   'Line hilite 1
  hicol2              As Long   'Line hilite 2
  hicol3              As Long   'Line hilite 3
  selbarbck           As Long   'Selection bar
  selbarpen           As Long   'Selection bar pen
  lnrcol              As Long   'Line numbers color
  numcol              As Long   'Numbers & hex
End Type

Public Type FINDTEXTEX
  chrg                As CHARRANGE
  lpstrText           As String
  chrgText            As CHARRANGE
End Type

Public Event SelChange(rasc As RASELCHANGE)
Public Event Changed()
Public Event BookmarkClicked(Line As Long, BMType As Long)
Public Event ButtonClicked(Button As Long)

Private Sub Timer1_Timer()
Dim lRet As Long
  If hwnd = evrasc Then
    evrasc = 0
    If rasc.seltyp = SEL_TEXT Then
      If rasc.fchanged Then
        RaiseEvent Changed
      End If
      RaiseEvent SelChange(rasc)
    Else
      lRet = SendMessage(hREd, REM_GETBOOKMARK, rasc.nline, ByVal 0)
      RaiseEvent BookmarkClicked(rasc.nline, lRet)
    End If
  End If
  If hwnd = evbutton Then
    evbutton = 0
    RaiseEvent ButtonClicked(nButton)
  End If
  If hfocus Then
    lRet = GetFocus
    lRet = GetParent(lRet)
    If lRet = hREd Then
      hfocus = 0
    Else
      Call ApiSetFocus(hREd)
    End If
  End If
End Sub

'Load property values from storage
Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
  Buttons = PropBag.ReadProperty("Buttons", False)
End Sub

'Write property values to storage
Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  Call PropBag.WriteProperty("Buttons", Buttons, False)
End Sub

Public Property Get Buttons() As Boolean
  Buttons = bButtons
End Property

Public Property Let Buttons(bButt As Boolean)
  bButtons = bButt
  PropertyChanged "Buttons"
  Call UserControl_Terminate
  Call UserControl_Initialize
  Call UserControl_Resize
End Property

Private Function LoadRAEditDLL() As Long
  LoadRAEditDLL = LoadLibrary("RAEdit.dll")
End Function

Private Function CreateRAEdit(hPar As Long) As Long
Dim lStyle As Long
  lStyle = &H50013044
  If Buttons Then
    lStyle = lStyle Xor 4
  End If
  CreateRAEdit = CreateWindowEx(&H200, "RAEDIT", 0, lStyle, 0, 0, 0, 0, hPar, 0, &H400000, 0)
End Function

Private Function SetRAEditFonts(ByVal sFont As String, lSize As Long) As Long
Dim lf As LOGFONT
Dim i As Integer
Dim szFont As String
  lf.lfHeight = -((lSize * GetDeviceCaps(hdc, LOGPIXELSY)) / 72)
  szFont = sFont & String(32, Chr(0))
  For i = 1 To 32
    lf.lfFaceName(i) = Asc(Mid(szFont, i, 1))
  Next i
  raf.hFont = CreateFontIndirect(lf)
  lf.lfItalic = True
  raf.hIFont = CreateFontIndirect(lf)
  lf.lfHeight = -8
  szFont = "Terminal" & String(32, Chr(0))
  For i = 1 To 32
    lf.lfFaceName(i) = Asc(Mid(szFont, i, 1))
  Next i
  lf.lfItalic = False
  raf.hLnrFont = CreateFontIndirect(lf)
  SetRAEditFonts = SendMessage(hREd, REM_SETFONT, 0, raf)
End Function

Private Function KillRAEditFonts() As Long
  KillRAEditFonts = DeleteObject(raf.hFont)
  KillRAEditFonts = DeleteObject(raf.hIFont)
  KillRAEditFonts = DeleteObject(raf.hLnrFont)
End Function

Private Function ReadRAEditFile(szFileName As String, lpStream As Long) As Long
Dim hFile As Long
Dim edts As EDITSTREAM
  Call SendMessage(hREd, WM_SETTEXT, 0, ByVal 0)
  hFile = CreateFile(szFileName, &H80000000, &H1, 0, &H3, &H80, 0)
  edts.dwCookie = hFile
  edts.pfnCallback = lpStream
  Call SendMessage(hREd, EM_STREAMIN, 1, edts)
  Call CloseHandle(hFile)
  Call SendMessage(hREd, EM_SETMODIFY, False, ByVal 0)
End Function

Private Function WriteRAEditFile(szFileName As String, ByVal lpStream As Long) As Long
Dim hFile As Long
Dim edts As EDITSTREAM
  hFile = CreateFile(szFileName, &H40000000, &H1, 0, &H2, &H80, 0)
  edts.dwCookie = hFile
  edts.pfnCallback = lpStream
  Call SendMessage(hREd, EM_STREAMOUT, 1, edts)
  Call CloseHandle(hFile)
  Call SendMessage(hREd, EM_SETMODIFY, False, ByVal 0)
End Function

Private Sub UserControl_Initialize()
  If LoadRAEditDLL Then
    hREd = CreateRAEdit(hwnd)
    Call SetRAEditFonts(Font.Name, Font.Size)
    Call MoveWindow(hREd, 0, 0, ScaleWidth, ScaleHeight, True)
    Call SetMsgHook(hwnd)
  Else
    MsgBox "RAEdit.dll not found"
  End If
End Sub

Private Sub UserControl_Resize()
Dim hWin As Long
  Call MoveWindow(hREd, 0, 0, ScaleWidth, ScaleHeight, True)
End Sub

Private Sub UserControl_Terminate()
  Call KillRAEditFonts
  Call RemoveMsgHook(hwnd)
  Call DestroyWindow(hREd)
End Sub

Public Function LoadFile(szFileName As String) As Long
  LoadFile = ReadRAEditFile(szFileName, AddressOf StreamFileIn)
End Function

Public Function SaveFile(szFileName As String) As Long
  SaveFile = WriteRAEditFile(szFileName, AddressOf StreamFileOut)
End Function

Public Function SetHiliteWords(ByVal nColor As Long, sWords As String)
  If sWords = "" Then
    SetHiliteWords = SendMessage(hREd, REM_SETHILITEWORDS, 0, ByVal 0)
  Else
    SetHiliteWords = SendMessage(hREd, REM_SETHILITEWORDS, nColor, ByVal sWords)
  End If
End Function

Public Function GetColors(col As RACOLOR)
  GetColors = SendMessage(hREd, REM_GETCOLOR, 0, col)
End Function

Public Function SetColors(col As RACOLOR)
  SetColors = SendMessage(hREd, REM_SETCOLOR, 0, col)
End Function

Public Function SetFonts(sFontName As String, lFontSize As Long) As Long
  Call KillRAEditFonts
  SetFonts = SetRAEditFonts(sFontName, lFontSize)
End Function

Public Function GetModify() As Long
  GetModify = SendMessage(hREd, EM_GETMODIFY, 0, ByVal 0)
End Function

Public Function SetModify(lModify As Long) As Long
  SetModify = SendMessage(hREd, EM_SETMODIFY, lModify, ByVal 0)
End Function

Public Function CanUndo() As Long
  CanUndo = SendMessage(hREd, EM_CANUNDO, 0, ByVal 0)
End Function

Public Function Undo() As Long
  Undo = SendMessage(hREd, EM_UNDO, 0, ByVal 0)
End Function

Public Function CanRedo() As Long
  CanRedo = SendMessage(hREd, EM_CANREDO, 0, ByVal 0)
End Function

Public Function Redo() As Long
  Redo = SendMessage(hREd, EM_REDO, 0, ByVal 0)
End Function

Public Function Cut() As Long
  Cut = SendMessage(hREd, WM_CUT, 0, ByVal 0)
End Function

Public Function Copy() As Long
  Copy = SendMessage(hREd, WM_COPY, 0, ByVal 0)
End Function

Public Function CanPaste() As Long
  CanPaste = SendMessage(hREd, EM_CANPASTE, CF_TEXT, ByVal 0)
End Function

Public Function Paste() As Long
  Paste = SendMessage(hREd, WM_PASTE, 0, ByVal 0)
End Function

Public Function Delete() As Long
  Delete = SendMessage(hREd, WM_CLEAR, 0, ByVal 0)
End Function

Public Function GotoLine(lLine As Long) As Long
Dim chrg As CHARRANGE
  GotoLine = SendMessage(hREd, EM_LINEINDEX, lLine, ByVal 0)
  chrg.cpMin = GotoLine
  chrg.cpMax = GotoLine
  Call SendMessage(hREd, EM_EXSETSEL, 0, chrg)
  Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
End Function

Public Function SetFocus() As Long
  hfocus = hREd
End Function

Public Function GetSel(chrg As CHARRANGE) As Long
  GetSel = SendMessage(hREd, EM_EXGETSEL, 0, chrg)
End Function

Public Function SetSel(chrg As CHARRANGE) As Long
  SetSel = SendMessage(hREd, EM_EXSETSEL, 0, chrg)
End Function

Public Function Clear() As Long
  Clear = SendMessage(hREd, WM_SETTEXT, 0, ByVal 0)
End Function

Public Function Find(flag As Long, txt As String) As Long
Dim ft As FINDTEXTEX
  Call SendMessage(hREd, EM_EXGETSEL, 0, ft.chrg)
  If flag And FR_DOWN Then
    If ft.chrg.cpMin <> ft.chrg.cpMax Then
      ft.chrg.cpMin = ft.chrg.cpMax
    End If
    ft.chrg.cpMax = -1
  Else
    ft.chrg.cpMax = 0
  End If
  ft.lpstrText = txt
  Find = SendMessage(hREd, EM_FINDTEXTEX, flag, ft)
  If Find <> -1 Then
    Call SendMessage(hREd, EM_EXSETSEL, 0, ft.chrgText)
    Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
  End If
End Function

Public Function Replace(txt As String) As Long
Dim chrg As CHARRANGE
  Call SendMessage(hREd, EM_EXGETSEL, 0, chrg)
  Replace = SendMessage(hREd, EM_REPLACESEL, 1, ByVal txt)
  chrg.cpMax = chrg.cpMin + Len(txt)
  Call SendMessage(hREd, EM_EXSETSEL, 0, chrg)
End Function

Public Function ToggleBookmark() As Long
Dim chrg As CHARRANGE
Dim lLine As Long
  Call SendMessage(hREd, EM_EXGETSEL, 0, chrg)
  lLine = SendMessage(hREd, EM_LINEFROMCHAR, chrg.cpMin, ByVal 0)
  ToggleBookmark = SendMessage(hREd, REM_GETBOOKMARK, lLine, ByVal 0)
  If ToggleBookmark = 3 Then
    Call SendMessage(hREd, REM_SETBOOKMARK, lLine, ByVal 0)
    ToggleBookmark = 0
  ElseIf ToggleBookmark = 0 Then
    Call SendMessage(hREd, REM_SETBOOKMARK, lLine, ByVal 3)
    ToggleBookmark = 1
  End If
End Function

Public Function NextBookmark() As Long
Dim chrg As CHARRANGE
Dim lLine As Long
  Call SendMessage(hREd, EM_EXGETSEL, 0, chrg)
  lLine = SendMessage(hREd, EM_LINEFROMCHAR, chrg.cpMin, ByVal 0)
  NextBookmark = SendMessage(hREd, REM_NXTBOOKMARK, lLine, ByVal 3)
  If NextBookmark <> -1 Then
    chrg.cpMin = SendMessage(hREd, EM_LINEINDEX, NextBookmark, ByVal 0)
    chrg.cpMax = chrg.cpMin
    Call SendMessage(hREd, EM_EXSETSEL, 0, chrg)
    Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
  End If
End Function

Public Function PreviousBookmark() As Long
Dim chrg As CHARRANGE
Dim lLine As Long
  Call SendMessage(hREd, EM_EXGETSEL, 0, chrg)
  lLine = SendMessage(hREd, EM_LINEFROMCHAR, chrg.cpMin, ByVal 0)
  PreviousBookmark = SendMessage(hREd, REM_PRVBOOKMARK, lLine, ByVal 3)
  If PreviousBookmark <> -1 Then
    chrg.cpMin = SendMessage(hREd, EM_LINEINDEX, PreviousBookmark, ByVal 0)
    chrg.cpMax = chrg.cpMin
    Call SendMessage(hREd, EM_EXSETSEL, 0, chrg)
    Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
  End If
End Function

Public Function ClearBookmarks() As Long
  ClearBookmarks = SendMessage(hREd, REM_CLRBOOKMARKS, 0, ByVal 3)
End Function

Public Function AnyBookmarks() As Long
  AnyBookmarks = SendMessage(hREd, REM_NXTBOOKMARK, -1, ByVal 3)
  If AnyBookmarks = -1 Then
    AnyBookmarks = 0
  Else
    AnyBookmarks = 1
  End If
End Function

Public Function SetBlocks(rabd As RABLOCKDEF) As Long
  SetBlocks = SendMessage(hREd, REM_SETBLOCKS, 0, rabd)
End Function

Public Function Collapse(Line As Long, rabd As RABLOCKDEF) As Long
  Collapse = SendMessage(hREd, REM_COLLAPSE, Line, rabd)
  Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
End Function

Public Function Expand(Line As Long) As Long
  Expand = SendMessage(hREd, REM_EXPAND, Line, ByVal 0)
  Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
End Function

Public Function CollapseAll(rabd As RABLOCKDEF) As Long
  CollapseAll = SendMessage(hREd, REM_COLLAPSEALL, 0, rabd)
  Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
End Function

Public Function ExpandAll() As Long
  ExpandAll = SendMessage(hREd, REM_EXPANDALL, 0, ByVal 0)
  Call SendMessage(hREd, EM_SCROLLCARET, 0, ByVal 0)
End Function

