Attribute VB_Name = "modRAEdit"
Option Explicit

Private Const GWL_WNDPROC = (-4)
Private Const WM_NOTIFY = &H4E
Private Const WM_SETFOCUS = &H7
Private Const WM_COMMAND = &H111

Public Type LOGFONT
  lfHeight            As Long
  lfWidth             As Long
  lfEscapement        As Long
  lfOrientation       As Long
  lfWeight            As Long
  lfItalic            As Byte
  lfUnderline         As Byte
  lfStrikeOut         As Byte
  lfCharSet           As Byte
  lfOutPrecision      As Byte
  lfClipPrecision     As Byte
  lfQuality           As Byte
  lfPitchAndFamily    As Byte
  lfFaceName(1 To 32) As Byte
End Type

Private PrevFuncPointer As Long
Public evrasc As Long
Public rasc As RASELCHANGE
Public evbutton As Long
Public nButton As Long
Private Declare Function ReadFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToRead As Long, ByVal lpNumberOfBytesRead As Long, ByVal lpOverlapped As Long) As Long
Private Declare Function WriteFile Lib "kernel32" (ByVal hFile As Long, ByVal lpBuffer As Long, ByVal nNumberOfBytesToWrite As Long, ByVal lpNumberOfBytesWritten As Long, ByVal lpOverlapped As Long) As Long
'Private Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
Private Declare Function CallWindowProc Lib "user32" Alias "CallWindowProcA" (ByVal lpPrevWndFunc As Long, ByVal hwnd As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (Destination As Any, Source As Any, ByVal Length As Long)

'Some Api's
Public Declare Function LoadLibrary Lib "kernel32" Alias "LoadLibraryA" (ByVal lpLibFileName As String) As Long
Public Declare Function CreateWindowEx Lib "user32" Alias "CreateWindowExA" (ByVal dwExStyle As Long, ByVal lpClassName As String, ByVal lpWindowName As String, ByVal dwStyle As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hWndParent As Long, ByVal hMenu As Long, ByVal hInstance As Long, lpParam As Any) As Long
Public Declare Function MoveWindow Lib "user32" (ByVal hWin As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal bRepaint As Long) As Long
Public Declare Function SendMessage Lib "user32" Alias "SendMessageA" (ByVal hWin As Long, ByVal wMsg As Long, ByVal wParam As Long, lParam As Any) As Long
Public Declare Function CreateFile Lib "kernel32" Alias "CreateFileA" (ByVal lpFileName As String, ByVal dwDesiredAccess As Long, ByVal dwShareMode As Long, ByVal lpSecurityAttributes As Long, ByVal dwCreationDisposition As Long, ByVal dwFlagsAndAttributes As Long, ByVal hTemplateFile As Long) As Long
Public Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Public Declare Function GetDeviceCaps Lib "gdi32" (ByVal hdc As Long, ByVal nIndex As Long) As Long
Public Declare Function CreateFontIndirect Lib "gdi32" Alias "CreateFontIndirectA" (lpLogFont As LOGFONT) As Long
Public Declare Function DeleteObject Lib "gdi32" (ByVal hObject As Long) As Long
Public Declare Function GetWindow Lib "user32" (ByVal hWin As Long, ByVal wCmd As Long) As Long
Public Declare Function ApiSetFocus Lib "user32" Alias "SetFocus" (ByVal hWin As Long) As Long
Public Declare Function GetFocus Lib "user32" () As Long
Public Declare Function GetParent Lib "user32" (ByVal hWin As Long) As Long
Public Declare Function DestroyWindow Lib "user32" (ByVal hwnd As Long) As Long
Public Declare Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long) As Long
Public Declare Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hwnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long


Public Function StreamFileIn(ByVal hFile As Long, ByVal pBuffer As Long, ByVal NumBytes As Long, ByVal pBytesRead As Long) As Long
  StreamFileIn = ReadFile(hFile, pBuffer, NumBytes, pBytesRead, 0)
  StreamFileIn = StreamFileIn Xor 1
End Function

Public Function StreamFileOut(ByVal hFile As Long, ByVal pBuffer As Long, ByVal NumBytes As Long, ByVal pBytesWritten As Long) As Long
  StreamFileOut = WriteFile(hFile, pBuffer, NumBytes, pBytesWritten, 0)
  StreamFileOut = StreamFileOut Xor 1
End Function

Private Function WndProc(ByVal hWin As Long, ByVal Msg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim nlen As Long
  If Msg = WM_NOTIFY Then
    nlen = Len(rasc.nmhd) + Len(rasc.chrg) + 2
    Call CopyMemory(rasc, ByVal lParam, nlen)
    lParam = lParam + nlen
    nlen = Len(rasc) - nlen - 2
    Call CopyMemory(rasc.nline, ByVal lParam, nlen)
    evrasc = hWin
    WndProc = 0
    Exit Function
  ElseIf Msg = WM_COMMAND Then
    evbutton = hWin
    nButton = 65534 - wParam
    WndProc = 0
    Exit Function
  End If
  WndProc = CallWindowProc(PrevFuncPointer, hWin, Msg, wParam, lParam)
End Function

Sub SetMsgHook(hWin As Long)
  PrevFuncPointer = SetWindowLong(hWin, GWL_WNDPROC, AddressOf WndProc)
End Sub

Sub RemoveMsgHook(hWin As Long)
  If PrevFuncPointer <> 0 Then
    Call SetWindowLong(hWin, GWL_WNDPROC, PrevFuncPointer)
  End If
End Sub


