VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "comdlg32.ocx"
Begin VB.Form frmRAEdit 
   Caption         =   "RAEdit"
   ClientHeight    =   6045
   ClientLeft      =   165
   ClientTop       =   450
   ClientWidth     =   9165
   Icon            =   "frmRAEdit.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   6045
   ScaleWidth      =   9165
   StartUpPosition =   2  'CenterScreen
   Begin VB.ComboBox cboFunction 
      Height          =   315
      Left            =   5220
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   0
      Width           =   3915
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   150
      Top             =   330
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Menu mnuFile 
      Caption         =   "&File"
      Begin VB.Menu mnuFileOpen 
         Caption         =   "&Open"
         Shortcut        =   ^O
      End
      Begin VB.Menu mnuFileSave 
         Caption         =   "&Save"
         Shortcut        =   ^S
      End
      Begin VB.Menu mnuFileSaveAs 
         Caption         =   "Save &As"
      End
      Begin VB.Menu mnuFileDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuFileExit 
         Caption         =   "&Exit"
      End
   End
   Begin VB.Menu mnuEdit 
      Caption         =   "&Edit"
      Begin VB.Menu mnuEditUndo 
         Caption         =   "&Undo	Ctrl+Z"
      End
      Begin VB.Menu mnuEditRedo 
         Caption         =   "&Redo	Ctrl+Y"
      End
      Begin VB.Menu mnuEditDiv1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditCut 
         Caption         =   "C&ut	Ctrl+X"
      End
      Begin VB.Menu mnuEditCopy 
         Caption         =   "&Copy	Ctrl+C"
      End
      Begin VB.Menu mnuEditPaste 
         Caption         =   "&Paste	Ctrl+V"
      End
      Begin VB.Menu mnuEditDelete 
         Caption         =   "&Delete	Del"
      End
      Begin VB.Menu mnuEditDiv2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuEditGoto 
         Caption         =   "&Goto line"
         Shortcut        =   ^G
      End
   End
   Begin VB.Menu mnuHelp 
      Caption         =   "&Help"
      Begin VB.Menu mnuHelpAbout 
         Caption         =   "&About"
      End
   End
End
Attribute VB_Name = "frmRAEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Activate()
Dim lRet As Long
  lRet = SetFocusToRAEdit
End Sub

Private Sub Form_Load()
Dim lRet As Long
  lRet = LoadDLL
  hREd = CreateRAEdit(Me.hwnd)
  lRet = SetHiliteWords
  lRet = SetColors
  lRet = SetFonts
  szCurrentFile = "(Untitled)"
End Sub

Private Sub Form_Resize()
Dim lRet As Long
  cboFunction.Left = Me.Width - cboFunction.Width - 120
  lRet = SizeRAEdit(hREd, 0, 28, Me.Width / 15 - 8, Me.Height / 15 - 28 - 19 - 28)
End Sub

Private Sub Form_Unload(Cancel As Integer)
Dim lRet As Long
  lRet = GetModify
  If lRet Then
    lRet = MsgBox("Save changes to" & vbCr & szCurrentFile & "?", vbYesNoCancel + vbQuestion)
    If lRet = vbYes Then
      Call mnuFileSave_Click
    ElseIf lRet = vbCancel Then
      Cancel = True
      Exit Sub
    End If
  End If
  lRet = KillFonts
End Sub

Private Sub mnuFileOpen_Click()
Dim lRet As Long
Dim szFileName As String
  CommonDialog1.Filter = "Assembly files (*.asm; *.inc)|*.asm;*.inc|All files (*.*)|*.*"
  CommonDialog1.FileName = szCurrentFile
  Call CommonDialog1.ShowOpen
  szFileName = CommonDialog1.FileName
  If Len(szFileName) Then
    szCurrentFile = szFileName
    lRet = LoadFile(szFileName, AddressOf StreamFileIn)
  End If
  lRet = SetFocusToRAEdit
End Sub

Private Sub mnuFileSave_Click()
Dim lRet As Long
  If szCurrentFile <> "(Untitled)" Then
    lRet = SaveFile(szCurrentFile, AddressOf StreamFileOut)
  Else
    Call mnuFileSaveAs_Click
  End If
End Sub

Private Sub mnuFileSaveAs_Click()
Dim lRet As Long
Dim szFileName As String
  CommonDialog1.Filter = "Assembly files (*.asm; *.inc)|*.asm;*.inc|All files (*.*)|*.*"
  CommonDialog1.FileName = szCurrentFile
  Call CommonDialog1.ShowSave
  szFileName = CommonDialog1.FileName
  If Len(szFileName) Then
    szCurrentFile = szFileName
    lRet = SaveFile(szFileName, AddressOf StreamFileOut)
  End If
  lRet = SetFocusToRAEdit
End Sub

Private Sub mnuFileExit_Click()
  Unload Me
End Sub

Private Sub mnuEditUndo_Click()
Dim lRet As Long
  lRet = Undo
End Sub

Private Sub mnuEditRedo_Click()
Dim lRet As Long
  lRet = Redo
End Sub

Private Sub mnuEditCut_Click()
Dim lRet As Long
  lRet = Cut
End Sub

Private Sub mnuEditCopy_Click()
Dim lRet As Long
  lRet = Copy
End Sub

Private Sub mnuEditPaste_Click()
Dim lRet As Long
  lRet = Paste
End Sub

Private Sub mnuEditDelete_Click()
Dim lRet As Long
  lRet = Delete
End Sub

Private Sub mnuEditGoto_Click()
Dim lRet As Long
  lRet = frmGotoLine.GotoLine
  If lRet > 0 Then
    lRet = GotoLine(lRet - 1)
  End If
End Sub


