   /*
    RadHexEditor For Visual C++ 6.0 - Converted By Wizzra
    ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    
    This Conversion uses KetilO's RadHexEditor Add-in 
    Hex Custom Control for the 'RadASM' IDE Inside Visual Studio IDE.

                                          - CopyRights by KetilO (R) 2003 -
                                          http://radasm.visualassembler.com/
    
    Enjoy the Conversion,
                          Wizzra 2003

*/
                                
#include <windows.h>
#include "resource\resource.h"
#include <commctrl.h>
#include <richedit.h>

#define WIN32_LEAN_AND_MEAN 

// RadHexEdit Styles
#define STYLE_NOSPLITT      0x01  // No splitt button
#define STYLE_NOLINENUMBER  0x02  // No linenumber button
#define STYLE_NOHSCROLL     0x04  // No horizontal scrollbar
#define STYLE_NOVSCROLL     0x08  // No vertical scrollbar
#define STYLE_NOSIZEGRIP    0x10  // No size grip
#define STYLE_NOSTATE       0x20  // No state indicator
#define STYLE_NOADDRESS     0x40  // No adress field
#define STYLE_NOASCII       0x80  // No ascii field
#define STYLE_NOUPPERCASE   0x100 // Hex numbers is lowercase letters
#define STYLE_READONLY      0x200 // Text is locked

// Private messages
#define HEM_RAINIT				 WM_USER+9999	// wParam=0, lParam=pointer to controls DIALOG struct
#define HEM_BASE                 WM_USER+1000

#define HEM_SETFONT				 HEM_BASE+1		// wParam=nLineSpacing, lParam=lpRAFONT
#define HEM_GETFONT				 HEM_BASE+2		// wParam=0, lParam=lpRAFONT
#define HEM_SETCOLOR			 HEM_BASE+3		// wParam=0, lParam=lpRACOLOR
#define HEM_GETCOLOR			 HEM_BASE+4		// wParam=0, lParam=lpRACOLOR
#define HEM_VCENTER				 HEM_BASE+5		// wParam=0, lParam=0
#define HEM_REPAINT				 HEM_BASE+6		// wParam=0, lParam=0
#define HEM_ANYBOOKMARKS		 HEM_BASE+7		// wParam=0, lParam=0
#define HEM_TOGGLEBOOKMARK		 HEM_BASE+8		// wParam=nLine, lParam=0
#define HEM_CLEARBOOKMARKS		 HEM_BASE+9		// wParam=0, lParam=0
#define HEM_NEXTBOOKMARK		 HEM_BASE+10	// wParam=0, lParam=0
#define HEM_PREVIOUSBOOKMARK	 HEM_BASE+11	// wParam=0, lParam=0
#define HEM_SELBARWIDTH			 HEM_BASE+12	// wParam=nWidth, lParam=0
#define HEM_LINENUMBERWIDTH		 HEM_BASE+13	// wParam=nWidth, lParam=0
#define HEM_SETSPLIT			 HEM_BASE+14	// wParam=nSplitt, lParam=0
#define HEM_GETSPLIT			 HEM_BASE+15	// wParam=0, lParam=0

#define DEFBCKCOLOR				 0x00C0F0F0
#define DEFADRTXTCOLOR			 0x00800000
#define DEFDTATXTCOLOR			 0x00000000
#define DEFASCTXTCOLOR			 0x00008000
#define DEFSELBCKCOLOR			 0x00800000
#define DEFLFSELBCKCOLOR		 0x00C0C0C0
#define DEFSELTXTCOLOR			 0x00FFFFFF
#define DEFSELASCCOLOR			 0x00C0C0C0
#define DEFSELBARCOLOR			 0x00C0C0C0
#define DEFSELBARPEN			 0x00808080
#define DEFLNRCOLOR				 0x00800000

// Global Variables
HINSTANCE hInst; 
HMODULE hRadHex;
char szFileName[MAX_PATH]="";

void LoadFileToRAHexEd    (HWND hWnd);
void SaveFileFromRAHexEd  (HWND hWnd);
void SaveFileAsFromRaHexEd(HWND hWnd);
void SaveFile(HWND RadWin,char *FileName);
void Hide_UnHide_RadHexAddress(HWND hWnd);
void Hide_UnHide_RadHexAscii(HWND hWnd);
void UpperLower_caseRadHex(HWND hWnd);

DWORD CALLBACK StreamInProc(DWORD dwCookie, LPBYTE lpbBuff, LONG cb, LONG FAR *pcb);
DWORD CALLBACK StreamOutProc(DWORD dwCookie, LPBYTE lpbBuff, LONG cb, LONG FAR *pcb);

BOOL CALLBACK DialogProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) // what are we doing ?
	{ 	 
		// This Window Message is the heart of the dialog //
		//================================================//
		case WM_INITDIALOG: 
		{                                                  
		}
		break;

		case WM_LBUTTONDOWN: 
		{
			ReleaseCapture(); 
			SendMessage(hWnd,WM_NCLBUTTONDOWN,HTCAPTION,0); 
		}
		break;

		case WM_PAINT: // constantly painting the window
		{
			return 0;
		}
		break;
		
        case WM_CLOSE: // We colsing the Dialog
        {
          EndDialog(hWnd,0); 
        }
	    break;

		case WM_COMMAND: // Controling the Buttons
		{
			switch (LOWORD(wParam)) // what we pressed on?
			{ 	 			    
                case IDM_OPEN_FILE:
                {
                    LoadFileToRAHexEd(hWnd); 
                }
                break;
                
                case IDM_SAVE_FILE:
                {
                    SaveFileFromRAHexEd(hWnd);
                }
                break;

                case IDM_SAVE_FILE_AS:
                {
                    SaveFileAsFromRaHexEd(hWnd);
                }
                break;

                case IDM_EXIT:
                {
                    HWND RadHexhWnd=GetDlgItem(hWnd,IDC_RAHEXEDIT);

                    if(SendMessage(RadHexhWnd,EM_GETMODIFY,0,0)==TRUE)
                    {
                        if(MessageBox(hWnd,"There Has Been Changes, Do You Want To Save Them?","Save Changes",MB_OKCANCEL|MB_ICONQUESTION)==IDOK)
                        {
                            SaveFileFromRAHexEd(hWnd);
                        }
                    }
                    
                    SendMessage(hWnd,WM_CLOSE,0,0);
                }
                break;

                case IDM_ADDRESS:
                {
                    Hide_UnHide_RadHexAddress(hWnd);
                }
                break;

                case IDM_ASCII:
                {
                    Hide_UnHide_RadHexAscii(hWnd);
                }
                break;

                case IDM_UPPERCASE:
                {
                    UpperLower_caseRadHex(hWnd);
                }
                break;
				
			}
			break;
		}
		break;
	}
	return 0;
}

void LoadFileToRAHexEd(HWND hWnd)
{
    	// File Select dialog struct
	OPENFILENAME ofn;	
    EDITSTREAM editstream;
    CHARRANGE chrg;
    HANDLE hFile;
    HWND RadHexhWnd=GetDlgItem(hWnd,IDC_RAHEXEDIT);
    HMENU Menu = GetMenu(hWnd);

	// Intialize struct
	ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ZeroMemory(&editstream, sizeof(EDITSTREAM));
    ZeroMemory(&chrg, sizeof(CHARRANGE));

	ofn.lStructSize = sizeof(OPENFILENAME); // SEE NOTE BELOW
    ofn.hwndOwner = hWnd;
    ofn.lpstrFilter = "Executable files (*.exe, *.dll)\0*.exe;*.dll\0ROM Files (*.gb,*.gbc)\0*.gb;*.gbc\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileName;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_EXPLORER | OFN_FILEMUSTEXIST | OFN_HIDEREADONLY;
	ofn.lpstrDefExt = "exe";
    
    if(GetOpenFileName(&ofn)!=NULL)
    {
        hFile=CreateFile(szFileName,
			GENERIC_READ|GENERIC_WRITE,
			FILE_SHARE_READ,
			NULL,
			OPEN_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL );        
    }
    else return;

    if(hFile==INVALID_HANDLE_VALUE)
            return;
    
    editstream.dwCookie = (DWORD)hFile;
    editstream.pfnCallback=StreamInProc;

    SendMessage(RadHexhWnd,EM_STREAMIN,(WPARAM)SF_TEXT,(LPARAM)&editstream);
    CloseHandle(hFile);
    SendMessage(RadHexhWnd,EM_SETMODIFY,FALSE,0);
    chrg.cpMin=0;
    chrg.cpMax=0;
    SendMessage(RadHexhWnd,EM_EXSETSEL,0,(LPARAM)&chrg);

    EnableMenuItem(Menu,IDM_SAVE_FILE,MF_ENABLED);
    EnableMenuItem(Menu,IDM_SAVE_FILE_AS,MF_ENABLED);

}

void SaveFileFromRAHexEd(HWND hWnd)
{
    HWND RadHexhWnd=GetDlgItem(hWnd,IDC_RAHEXEDIT);            

    // content of edit control has been modified?
    if(SendMessage(RadHexhWnd,EM_GETMODIFY,0,0)==TRUE)
    {
        SaveFile(RadHexhWnd,szFileName);
    }
    else MessageBox(hWnd,"Nothing To Save, No Changes!","Opps",MB_OK);
}


void SaveFileAsFromRaHexEd(HWND hWnd)
{
    HWND RadHexhWnd=GetDlgItem(hWnd,IDC_RAHEXEDIT);
    OPENFILENAME ofn;
    char szFileNameSave[MAX_PATH]="";

    ZeroMemory(&ofn, sizeof(OPENFILENAME)); // Init the struct to Zero
    ofn.lStructSize = sizeof(OPENFILENAME); // SEE NOTE BELOW
    ofn.hwndOwner = hWnd;
    ofn.lpstrFilter = "Executable files (*.exe, *.dll)\0*.exe;*.dll\0ROM Files (*.gb,*.gbc)\0*.gb;*.gbc\0All Files (*.*)\0*.*\0";
	ofn.lpstrFile = szFileNameSave;
	ofn.nMaxFile = MAX_PATH;
	ofn.Flags = OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_HIDEREADONLY | OFN_FILEMUSTEXIST;
	ofn.lpstrDefExt = "exe";

    // content of edit control has been modified?
    if(SendMessage(RadHexhWnd,EM_GETMODIFY,0,0)==TRUE)
    {
        if(GetSaveFileName(&ofn)!=NULL)
        {
            SaveFile(RadHexhWnd,szFileNameSave);
        }
        else return;
    }
    else MessageBox(hWnd,"Nothing To Save, No Changes!","Opps",MB_OK);
}

DWORD CALLBACK StreamInProc(DWORD dwCookie, LPBYTE lpbBuff, LONG cb, LONG FAR *pcb)
{
    HANDLE hFile = (HANDLE)dwCookie;

    if (!ReadFile(hFile,
            (LPVOID)lpbBuff, cb, (LPDWORD)pcb, NULL))
        return((DWORD)-1);
    return(0);
}

DWORD CALLBACK StreamOutProc(DWORD dwCookie, LPBYTE lpbBuff, LONG cb, LONG FAR *pcb)
{
    HANDLE hFile = (HANDLE)dwCookie;

    if (!WriteFile(hFile,
            (LPVOID)lpbBuff, cb, (LPDWORD)pcb, NULL))
        return((DWORD)-1);
    return(0);
}

void SaveFile(HWND RadWin,char *FileName)
{
    EDITSTREAM editstream;    
    HANDLE hFile;

    // Init the struct to Zero
    ZeroMemory(&editstream, sizeof(EDITSTREAM));

    hFile=CreateFile(FileName,
            GENERIC_WRITE,
            FILE_SHARE_READ,
            NULL,
            OPEN_ALWAYS,
            FILE_ATTRIBUTE_NORMAL,
            NULL );
    
    if(hFile==INVALID_HANDLE_VALUE)
        return;
    
    editstream.dwCookie = (DWORD)hFile;
    editstream.pfnCallback=StreamOutProc;
    SendMessage(RadWin,EM_STREAMOUT,(WPARAM)SF_TEXT,(LPARAM)&editstream);
    CloseHandle(hFile);
    SendMessage(RadWin,EM_SETMODIFY,FALSE,0);
}

void Hide_UnHide_RadHexAddress(HWND hWnd)
{
    HWND RadHWnd = GetDlgItem(hWnd,IDC_RAHEXEDIT);
    HMENU Menu = GetMenu(hWnd);
    DWORD Style=0;

    Style = GetWindowLong(RadHWnd,GWL_STYLE);

    if((GetMenuState(Menu,IDM_ADDRESS,MF_BYCOMMAND)==MF_CHECKED))
    {
        // Set Style Off
        Style |= STYLE_NOADDRESS;
        CheckMenuItem(Menu,IDM_ADDRESS,MF_UNCHECKED);
    }
    else{
        // Set Style On
        Style &= (-1 ^ STYLE_NOADDRESS);
        CheckMenuItem(Menu,IDM_ADDRESS,MF_CHECKED);
    }

    SetWindowLong(RadHWnd,GWL_STYLE,Style);
    SendMessage(RadHWnd,HEM_REPAINT,0,0);
}

void Hide_UnHide_RadHexAscii(HWND hWnd)
{
    HWND RadHWnd = GetDlgItem(hWnd,IDC_RAHEXEDIT);
    HMENU Menu = GetMenu(hWnd);
    DWORD Style=0;

    Style = GetWindowLong(RadHWnd,GWL_STYLE);

    if((GetMenuState(Menu,IDM_ASCII,MF_BYCOMMAND)==MF_CHECKED))
    {
        // Set Style Off
        Style |= STYLE_NOASCII;
        CheckMenuItem(Menu,IDM_ASCII,MF_UNCHECKED);
    }
    else{
        // Set Style On
        Style &= (-1 ^ STYLE_NOASCII);
        CheckMenuItem(Menu,IDM_ASCII,MF_CHECKED);
    }

    SetWindowLong(RadHWnd,GWL_STYLE,Style);
    SendMessage(RadHWnd,HEM_REPAINT,0,0);
}

void UpperLower_caseRadHex(HWND hWnd)
{
    HWND RadHWnd = GetDlgItem(hWnd,IDC_RAHEXEDIT);
    HMENU Menu = GetMenu(hWnd);
    DWORD Style=0;

    Style = GetWindowLong(RadHWnd,GWL_STYLE);

    if((GetMenuState(Menu,IDM_UPPERCASE,MF_BYCOMMAND)==MF_CHECKED))
    {
        // Set Style Off
        Style |= STYLE_NOUPPERCASE;
        CheckMenuItem(Menu,IDM_UPPERCASE,MF_UNCHECKED);
    }
    else{
        // Set Style On
        Style &= (-1 ^ STYLE_NOUPPERCASE);
        CheckMenuItem(Menu,IDM_UPPERCASE,MF_CHECKED);
    }

    SetWindowLong(RadHWnd,GWL_STYLE,Style);
    SendMessage(RadHWnd,HEM_REPAINT,0,0);
}

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance, PSTR szCmdLine, int iCmdShow)
{
	hInst=hInstance;
    // Load the RadHexEdit Control
    hRadHex = LoadLibrary("RAHexEd.dll");
    if(!hRadHex)
    {
        MessageBox(NULL,"RAHexEd.dll Not Found!","Error Locating DLL",MB_OK|MB_ICONEXCLAMATION);
        return 0;
    }

	DialogBoxParam(hInstance, MAKEINTRESOURCE(IDD_DIALOG), NULL, (DLGPROC)DialogProc,0);
	FreeLibrary(hRadHex);
	return 0;
}